Page 1 of 1

Installing polymake on macOS 10.15.7: Term::Readline::Gnu error

Posted: 09 Dec 2022, 15:48
by Aryaman
Hi!

I'm trying to install polymake 4.7 on a macOS 10.15.7 (Intel processor) and I seemed to be able to install all of the dependencies that used Perlbrew without an issue except for one, the Term::ReadLine::Gnu. I should maybe mention the places where I deviated from the polymake instructions:
1) I ran

Code: Select all

tar -xvf polymake-4.7.tar.bz2
instead of tar -xvfj because the latter resulted in the error Couldn't open 'j'.
2) I ran the ninja -C command without sudo.

When I tried running cpanm Term::ReadLine::Gnu I got the following output:

Code: Select all

aryamanjal@Aryamans-MacBook-Pro polymake-4.7 % cpanm Term::ReadLine::Gnu --> Working on Term::ReadLine::Gnu Fetching http://www.cpan.org/authors/id/H/HA/HAYASHI/Term-ReadLine-Gnu-1.45.tar.gz ... OK Configuring Term-ReadLine-Gnu-1.45 ... N/A ! Configure failed for Term-ReadLine-Gnu-1.45. See /Users/aryamanjal/.cpanm/work/1670595481.15948/build.log for details.
And as you might expect, the build.log says:

Code: Select all

Unpacking Term-ReadLine-Gnu-1.45.tar.gz Entering Term-ReadLine-Gnu-1.45 Checking configure dependencies from META.json Checking if you have ExtUtils::MakeMaker 6.58 ... Yes (7.64) Configuring Term-ReadLine-Gnu-1.45 Running Makefile.PL readdir() attempted on invalid dirhandle $dir_fh at /Users/aryamanjal/perl5/lib$ closedir() attempted on invalid dirhandle $dir_fh at /Users/aryamanjal/perl5/li$ readdir() attempted on invalid dirhandle $dir_fh at /Users/aryamanjal/perl5/lib$ closedir() attempted on invalid dirhandle $dir_fh at /Users/aryamanjal/perl5/li$ !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! The libreadline you are using is the libedit library. Use the GNU Readline Lib$ !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! -> N/A -> FAIL Configure failed for Term-ReadLine-Gnu-1.45. See /Users/aryamanjal/.cpa$
The fixes suggested online to switch from the libedit library to the GNU Readline Lib involves

Code: Select all

brew link --force readline cpanm Term::ReadLine::Gnu brew unlink readline
which is what the polymake instructions suggests is only necessary for macOS 10.14. For reference, a similiar issue was what encountered by someone in this post
https://forum.polymake.org/viewtopic.php?t=1840


The rest of the installation went through fine and when I call polymake I get the following output:

Code: Select all

aryamanjal@Aryamans-MacBook-Pro polymake-4.7 % polymake Welcome to polymake version 4.7 Copyright (c) 1997-2022 Ewgenij Gawrilow, Michael Joswig, and the polymake team Technische Universit├Ąt Berlin, Germany https://polymake.org This is free software licensed under GPL; see the source for copying conditions. There is NO warranty; not even for MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. Loading applications now...Can't locate object method "new" via package "Term::ReadLine::Gnu" at /usr/local/share/polymake/perllib/Polymake/Core/Shell.pm line 54.
So if you have any pointers on how to resolve this error or perhaps reinstall, I would be grateful to hear them. Thanks in advance.